#!/bin/bash
if [ "$1" == "--help" -o "$1" == "" ]; then
    cat << EOF
MakeParFile.sh: This script creates the .par file for a given package. Par 
                files used by PROOF to transfer the code to the slaves.

SYNTAX: ./MakeParFile.sh packagedir [packagename]
         * packagedir: The name where the package is placed
         * packagename: The name of the par file holding the package. If it
                        is not provided the value packagedir.par will be used.

EOF
     exit
fi

packagedir=$1

path=`dirname $packagedir`
name=`basename $packagedir`

if [ "$2" == "" ]; then
    packagename=$name.par
else
    packagename=$2
fi

if [ ! -d $packagedir/PROOF-INF ]; then
    echo "ERROR: Could not find $packagedir/PROOF-INF"
    echo "       $packagedir is not a PROOF package. Exiting!"
    exit
fi
if [ ! -e $packagedir/PROOF-INF/SETUP.C ]; then
    echo "ERROR: Could not find $packagedir/PROOF-INF/SETUP.C"
    echo "       $packagedir is not a PROOF package. Exiting!"
    exit
fi

echo "Adding files in $packagedir to $packagename..."


cd $path
tar --exclude CVS --exclude "*~" --exclude "*.so" --exclude "*.d" -c -v -z -f $packagename $name

